config/routes.rb
require 'avalon/routing/can_constraint'

Rails.application.routes.draw do
  mount Samvera::Persona::Engine => '/'
  mount Blacklight::Engine => '/catalog'
  concern :searchable, Blacklight::Routes::Searchable.new
  concern :exportable, Blacklight::Routes::Exportable.new

  resource :catalog, only: [:index], as: 'catalog', path: '/catalog', controller: 'catalog' do
    concerns :searchable
  end

  # For some reason this needs to be after `resource :catalog` otherwise Blacklight will generate links to / instead of /catalog
  root to: "catalog#index"

  get '/mejs/:version', to: 'application#mejs'

  resources :solr_documents, only: [:show], path: '/catalog', controller: 'catalog' do
    concerns :exportable
  end

  resources :encode_records, only: [:show, :index] do
    collection do
      post :paged_index
      post :progress
    end
  end

  resources :bookmarks do
    concerns :exportable

    collection do
      delete 'clear'
      get 'delete'#, as: :delete_bookmarks
      post 'delete'
      get 'move'#, as: :move_bookmarks
      post 'move'
      get 'update_access_control'#, as: :update_access_control_bookmarks
      post 'update_access_control'
      post 'publish'#, as: :publish_bookmarks
      post 'unpublish'#, as: :unpublish_bookmarks
      get 'add_to_playlist'
      post 'add_to_playlist'
      get 'intercom_push'
      post 'intercom_push'
      get 'merge'
      post 'merge'
    end
  end

  devise_for :users, controllers: { omniauth_callbacks: 'users/omniauth_callbacks', sessions: 'users/sessions' }, format: false
  devise_scope :user do
    match '/users/auth/:provider', to: 'users/omniauth_callbacks#passthru', as: :user_omniauth_authorize, via: [:get, :post]
    Avalon::Authentication::Providers.collect { |provider| provider[:provider] }.uniq.each do |provider_name|
      match "/users/auth/#{provider_name}/callback", to: "users/omniauth_callbacks##{provider_name}", as: "user_omniauth_callback_#{provider_name}".to_sym, via: [:get, :post]
    end
  end

  mount BrowseEverything::Engine => '/browse'

  # Avalon routes
  match "/authorize", to: 'derivatives#authorize', via: [:get, :post]
  match "/authorize/:path", to: 'derivatives#authorize', via: [:get, :post]

  namespace :admin do
    resources :groups, except: [:show] do
      collection do
        put 'update_multiple'
      end
      member do
        put 'update_users'
      end
    end
    resources :collections do
      member do
        get 'edit'
        get 'remove'
        get 'items'
        get 'poster'
        post 'poster', action: :attach_poster, as: 'attach_poster'
        delete 'poster', action: :remove_poster, as: 'remove_poster'
      end
    end

    namespace :migration_report, controller: '/migration_status' do
      get '/', action: :index
      get ':class', action: :show, as: 'by_class'
      get ':id/detail', action: :detail, as: 'detail'
      get ':id/report', action: :report, as: 'report'
    end
  end

  resources :vocabulary, except: [:create, :destroy, :new, :edit]

  resources :collections, only: [:index, :show] do
    member do
      get :poster
    end
  end

  resources :media_objects, except: [:create, :update] do
    member do
      put :update, action: :update, defaults: { format: 'html' }, constraints: { format: 'html' }
      put :update, action: :json_update, constraints: { format: 'json' }
      patch :update, action: :update, defaults: { format: 'html' }, constraints: { format: 'html' }
      put :update_status
      get :progress, :action => :show_progress
      get 'content/:file', :action => :deliver_content, :as => :inspect
      get 'track/:part', :action => :show, :as => :indexed_section
      get 'section/:content', :action => :show, :as => :id_section
      get 'section/:content/stream', :action => :show_stream_details, :as => :section_stream
      get 'section/:content/embed', :to => redirect('/master_files/%{content}/embed')
      get 'tree', :action => :tree, :as => :tree
      get :confirm_remove
      get :add_to_playlist_form
      post :add_to_playlist
      patch :intercom_push
      get :manifest
      get :move_preview, defaults: { format: 'json' }, constraints: { format: 'json' }
    end
    collection do
      post :create, action: :create, constraints: { format: 'json' }
      post :set_session_quality
      get :confirm_remove
      put :update_status
      # 'delete' has special signifigance so use 'remove' for now
      delete :remove, :action => :destroy
      get :intercom_collections
    end

    # Supplemental Files
    resources :supplemental_files, except: [:new, :index, :edit]
  end

  resources :master_files, except: [:new, :index] do
    member do
      get  'thumbnail', :to => 'master_files#get_frame', :defaults => { :type => 'thumbnail' }
      get  'poster',    :to => 'master_files#get_frame', :defaults => { :type => 'poster' }

      post 'thumbnail', :to => 'master_files#set_frame', :defaults => { :type => 'thumbnail', :format => 'html' }
      post 'poster',    :to => 'master_files#set_frame', :defaults => { :type => 'poster', :format => 'html' }
      post 'still',     :to => 'master_files#set_frame', :defaults => { :format => 'html' }
      get :embed
      post 'attach_structure'
      post 'attach_captions'
      get :captions
      get :waveform
      match ':quality.m3u8', to: 'master_files#hls_manifest', via: [:get], as: :hls_manifest
      get 'structure', to: 'master_files#structure', constraints: { format: 'json' }
      post 'structure', to: 'master_files#set_structure', constraints: { format: 'json' }
      delete 'structure', to: 'master_files#delete_structure', constraints: { format: 'json' }
      post 'move'
    end

    # Supplemental Files
    resources :supplemental_files, except: [:new, :index, :edit]
  end

  match "iiif_auth_token/:id", to: 'master_files#iiif_auth_token', via: [:get], as: :iiif_auth_token

  resources :derivatives, only: [:create]
  match "/autocomplete", to: 'objects#autocomplete', via: [:get]
  match "/objects/:id", to: 'objects#show', via: [:get], :as => :objects
  match "/object/:id", to: 'objects#show', via: [:get]

  resources :playlists do
    resources :playlist_items, path: 'items', only: [:create, :update, :show] do
      get 'markers'
      get 'source_details'
      get 'related_items'
    end
    member do
      patch 'update_multiple'
      delete 'update_multiple'
      patch 'regenerate_access_token'
      get 'refresh_info'
    end
    collection do
      post 'duplicate'
      post 'paged_index'
      if Settings['variations'].present?
        post 'import_variations_playlist'
      end
    end
  end

  resources :avalon_marker, only: [:create, :show, :update, :destroy]

  resources :comments, only: [:index, :create]

  resources :playlist_items, only: [:update], :constraints => {:format => /(js|json)/}

  resources :timelines do
    member do
      patch 'regenerate_access_token'
      post 'manifest', to: 'timelines#manifest_update', constraints: { format: 'json' }
      get 'manifest', constraints: { format: 'json' }
    end
    collection do
      post 'duplicate'
      post 'paged_index'
      if Settings['variations'].present?
        post 'import_variations_timeline'
      end
    end
  end
  get '/timeliner', to: 'timelines#timeliner', as: :timeliner

  resources :dropbox, :only => [] do
    collection do
      delete :bulk_delete
    end
  end

  match "/oembed", to: 'master_files#oembed', via: [:get]

  constraints(Avalon::Routing::CanConstraint.new(:read, :about_page)) do
    mount AboutPage::Engine => '/about(.:format)', as: 'about_page'
  end
  get '/about(.:format)', to: redirect('/')
  get '/about/health.yaml', to: 'about_page/about#health', defaults: { :format => 'yaml' }
  get '/about/health(.:format)', to: redirect('/')

  constraints(Avalon::Routing::CanConstraint.new(:manage, :jobs)) do
    mount Sidekiq::Web, at: '/jobs', as: 'jobs'
  end
  get '/jobs(.:format)', to: redirect('/')
end

app/controllers/collections_controller.rb
# Copyright 2011-2020, The Trustees of Indiana University and Northwestern
#   University.  Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software distributed
#   under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
#   CONDITIONS OF ANY KIND, either express or implied. See the License for the
#   specific language governing permissions and limitations under the License.
# ---  END LICENSE_HEADER BLOCK  ---

class CollectionsController < CatalogController
  skip_before_action :enforce_show_permissions, only: :show

  def index
    response = repository.search(CollectionSearchBuilder.new(self))
    collections = response.documents
    if (params[:only] == 'carousel')
      collections = collections.select { |doc| Settings.home_page&.carousel_collections&.include? doc.id }
    end
    if params[:limit].present?
      collections = collections.sample(params[:limit].to_i)
    end
    @doc_presenters = collections.collect { |doc| CollectionPresenter.new(doc, view_context) }

    respond_to do |format|
      format.html
      format.json { render json: @doc_presenters }
    end
  end

  def show
    response = repository.search(CollectionSearchBuilder.new(self))
    document = response.documents.find { |doc| doc.id == params[:id] }
    # Only go on if params[:id] is in @document_list
    raise CanCan::AccessDenied unless document
    @doc_presenter = CollectionPresenter.new(document, view_context)

    respond_to do |format|
      format.html
      format.json { render json: @doc_presenter }
    end
  end

  def poster
    response = repository.search(CollectionSearchBuilder.new(self))
    document = response.documents.find { |doc| doc.id == params[:id] }
    # Only go on if params[:id] is in @document_list
    raise CanCan::AccessDenied unless document

    @collection = Admin::Collection.find(params['id'])

    file = @collection.poster
    if file.nil? || file.new_record?
      render plain: 'Collection Poster Not Found', status: :not_found
    else
      render plain: file.content, content_type: file.mime_type
    end
  end
end

app/views/admin/collections/_apply_access_control.html.erb
<div id="access_control_modal" class="modal fade">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
          <div class="modal-header">
              <button type="button" class="close" data-dismiss="modal">
                <span aria-hidden="true">&times;</span>
                <span class="sr-only">Close</span>
              </button>
              <h4 class='modal-title'><%= modal_title %></h4>
          </div>
          <div class="modal-body">
            <p>Would you like to keep all existing Special access entries on items (users, groups, IP addresses), and add the current access control settings?</p>
            <div class="form-group">
              <div class="radio">
                <label>
                  <%= radio_button_tag :overwrite, 'false', true %>
                  Yes, add to existing Special Access entries
                </label>
              </div>
              <div class="radio">
                <label>
                  <%= radio_button_tag :overwrite, 'true', false %>
                  No, replace existing Special Access entries
                </label>
              </div>
            </div>
          </div>
          <div class="modal-footer">
            <a href="#" data-dismiss="modal" aria-hidden="true" class="btn btn-default">Cancel</a>
            <%= submit_tag "Apply", name: "apply_access", class: "btn btn-primary", form: 'access_control_form' %>
          </div>
        </div>
    </div>
</div>

app/views/admin/collections/_form.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>

<div id="new_collection" class="modal fade" role="dialog" data-backdrop="true" data-submit_url="<%= 'create' %>">
  <div class="modal-dialog modal-lg">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span
            class="sr-only">Close</span></button>
        <h4 class='modal-title'><%= modal_title %></h4>
      </div>
      <%= bootstrap_form_for @collection, remote: true, html: { modal: true }, format: 'json' do |f| %>
      <div class="modal-body">
        <%= f.text_field :name %>
        <% if @collection.new_record? || can?(:update_unit, @collection)%>
        <%= f.select(:unit, Admin::Collection.units) %>
        <% end %>
        <%= f.text_area :description, rows: 3  %>
        <%= f.text_field :contact_email %>
        <%= f.text_field :website_url %>
        <%= f.text_field :website_label %>
      </div>
      <div class="modal-footer">
        <a href="#" data-dismiss="modal" aria-hidden="true" class="btn btn-default">Cancel</a>
        <%= f.submit class: 'btn btn-primary btn-stateful-loading', data: {loading_text: 'Saving...'} %>
      </div>
      <% end %>
    </div>
  </div>
</div>


<% content_for :page_scripts do %>
<script>
  function inject_alert(message) {
    let alertElement = $('#alerts');
    // Remove alert with previous errors
    if(alertElement) {
      alertElement.remove();
    }
    $('.page-title').closest('.page-title-wrapper').before(
      '<div class="container-fluid" id="alerts"><div class="alert alert-danger"><button type="button" class="close" data-dismiss="alert">&times;</button>' +
      message + '</div></div>');
  }

  $('form[data-remote][modal]').on('ajax:complete', function (jq_event, xhr) {
    if (xhr.responseJSON.hasOwnProperty('errors')) {
      $(this).closest('.modal').modal('hide')
      if(xhr.responseJSON['errors'].length > 2) {
        // When there are multiple errors
        let markup = xhr.responseJSON['errors'][0];
        xhr.responseJSON['errors'].shift();
        xhr.responseJSON['errors'].forEach(msg => {
          markup += "<li>" + msg + "</li>"
        })
        inject_alert(markup);
      } else {
        // When there is one error
        inject_alert(xhr.responseJSON['errors'].join(' '));
      }
      $('.btn-stateful-loading').button('reset')
    } else window.location = '/admin/collections/' + encodeURIComponent(xhr.responseJSON['id']);
  });
</script>
<% end %>

app/views/admin/collections/index.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% @page_title = t('collections.title', :application_name => application_name) %>

<% unless @collections.empty? %>
<div class="row display-flex page-title-wrapper">
  <div class="col-xs-6">
    <h1 class="page-title">My Collections</h1>
  </div>
  <div class="col-xs-6 collection-btn">
    <%= button_tag("Create Collection", class: 'btn btn-primary btn-large', data: {toggle:"modal", target:"#new_collection"}) unless cannot? :create, Admin::Collection %>
  </div>
</div>


<div class="collections-list-wrapper">
  <table class='table table-striped'>
    <thead>
      <tr>
        <th>Title</th>
        <th>Items</th>
        <th>Managers</th>
        <th>Description</th>
        <th></th>
      </tr>
    </thead>
    <tbody>
      <% @collections.to_a.each do |collection| %>
      <tr>
        <td> <strong><%= link_to collection.name, admin_collection_path(collection.id) %></strong> </td>
        <td>
          <%= link_to(pluralize(collection.media_object_count, 'item'), search_catalog_path('f[collection_ssim][]' => collection.name)) %>
          <% if collection.unpublished_media_object_count > 0 %>
          <%=link_to("(#{collection.unpublished_media_object_count} unpublished)", search_catalog_path('f[collection_ssim][]' => collection.name, 'f[workflow_published_sim][]' => "Unpublished")) %>
          <% end %>
        </td>
        <td> <%= pluralize(collection.manager_count, 'manager') %> </td>
        <td> <%= collection.description&.truncate(100, separator: ' ') %> </td>
        <td class="text-right">
          <% if can?(:destroy, collection) %>
          <div class="btn-group">
            <%= link_to('Delete', remove_admin_collection_path(collection.id), class: 'btn btn-danger btn-sm')%>
          </div>
          <% else %>
          &nbsp;
          <% end %>
        </td>
      </tr>
      <% end %>
    </tbody>
  </table>
</div>

<% else %>
<div class="hero-unit">
  <h2>You don't have any collections yet</h2>

  <% if can? :create, Admin::Collection %>
  <p>Would you like to create one?</p>
  <div class="whitespace"></div>
  <p>
    <%= button_tag("Create Collection", class: 'btn btn-primary btn-large', data: {toggle:"modal", target:"#new_collection"}) %>
  </p>
  <% else %>
  <p>You'll need to be assigned to one</p>
  <% end %>

</div>
<% end %>



<% @collection = Admin::Collection.new %>
<%= render "form", modal_title: "Create Collection" %>

app/views/admin/collections/new.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<%= render :partial => 'form', locals: { modal_title: 'Create Collection' } %>

app/views/admin/collections/remove.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% content_for :page_scripts do %>
<%= javascript_include_tag 'select2.min' %>
<%= stylesheet_link_tag 'select2.min' %>
<script type="text/javascript">
  $('#target_collection_id').select2();
</script>
<% end %>

<div class="row" style="padding-top: 3rem;">
  <div class="col-md-8 col-md-offset-2">
    <%
    item_count = "#{@objects.count} #{'item'.pluralize(@objects.count)}"
    content_pronoun = @objects.count > 1 ? 'them' : 'it'
  %>

    <% if @collection.dropbox_object_count > 0 %>
      <div class="alert alert-warning">
        <span class="glyphicon glyphicon-warning-sign" aria-hidden="true"></span>
        <span>There are saved files in this collection's <b>Dropbox</b> that will be deleted when this collection is deleted.</span>
      </div>
    <% end %>

    <% if @collection.media_objects.count == 0 or @candidates.count > 0 %>
      <div class="alert alert-danger">
        <span class="glyphicon glyphicon-warning-sign" aria-hidden="true"></span>
        <span>Are you certain you want to remove the collection <b><%=@collection.name%></b>?</span>
      </div>

      <%= bootstrap_form_for @collection, method: :delete do |f| %>
      <% if @objects.count > 0 %>

      <h2>Reassign Existing Items</h2>
      <p>
        <b><%=@collection.name%></b> currently contains <%=item_count%>. Before you can
        delete it, you must select a new collection to move <%=content_pronoun%>
        into.
      </p>
      <div class="form-group">
        <%= select_tag :target_collection_id, options_from_collection_for_select(@candidates, "id", "name"), class: "form-control" %>
      </div>
    <% end %>

    <div class="form-group">
      <%= f.submit 'Yes, I am sure', class: 'btn btn-danger' %>
      <%= link_to 'No, go back', admin_collections_path, class: 'btn btn-default' %>
    </div>
    <% end %>
    <% else %>
    <div class="alert alert-danger">
      The collection "<%=@collection.name%>" cannot be deleted. It contains <%=item_count%>,
      but you do not have sufficient rights to any other collections to reassign <%=content_pronoun%>.
    </div>
    <%= link_to 'Go back', :back, class: 'btn btn-primary' %>
    <% end %>
  </div>
</div>

app/views/admin/collections/show.html.erb
<%#
Copyright 2011-2020, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% @page_title = t('collections.show.title', :collection_name => @collection.name, :application_name => application_name) %>

<div class="page-title-wrapper">
  <h1 class="page-title">Manage Content</h1>
</div>
<div class="modal fade" id="modal" data-backdrop="static" tabindex="-1" role="dialog" aria-labelledby="modalLabel"
  aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h1 class="modal-title" id="modalLabel">Crop the image</h1>
      </div>
      <div class="modal-body">
        <div class="img-container">
          <img id="image" src="" style="max-width: 100%;">
        </div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal" id="crop-cancel">Cancel</button>
        <button type="button" class="btn btn-primary" id="crop">Upload</button>
      </div>
    </div>
  </div>
</div>
<div class="well">
  <h2><%= @collection.name %></h2>
  <div class="row">
    <div class="col-md-9">
      <p><strong>Unit:</strong></p>
      <p><%= @collection.unit %></p>
      <p><strong>Description:</strong></p>
      <p class="collection-description"><%= @collection.description %></p>
      <% if @collection.contact_email.present? %>
        <p><strong>Contact email:</strong></p>
        <p><%= mail_to(@collection.contact_email) %></p>
      <% end %>
      <% if @collection.website_url.present? %>
        <p><strong>Website:</strong></p>
        <p><%= link_to(@collection.website_label.presence || @collection.website_url, @collection.website_url)%></p>
      <% end %>
    </div>
    <div class="col-md-3">
      <p><strong>Poster:</strong></p>
      <p id="poster_original_name"><%= @collection.poster.original_name if @collection.poster.present? %></p>
      <div class="well-vertical-spacer">
        <% if @collection.poster.present? %>
        <%= image_tag(poster_admin_collection_path(@collection), class: 'img-responsive', id: 'poster-image') %>
        <% else %>
        <img src="" class="img-responsive" id="poster-image">
        <% end %>
      </div>
      <div class="collection_poster">
        <%= form_for @collection, url: attach_poster_admin_collection_path(@collection.id), html: {method: "post"} do |form| %>
          <%= form.file_field :poster, id: 'poster_input', class: "filedata", style: "height:0px;width:0px;" %>
          <input type="button" class="btn btn-primary btn-xs" onclick="$('.filedata').click();" value="<% if @collection.poster.present? %>Change Poster<%else%>Upload Poster<%end%>"
            <% if cannot?(:edit, @collection) %>disabled<%end%> />
        <% end %>
        <%= form_for @collection, url: remove_poster_admin_collection_path(@collection.id), html: {method: "delete"} do |form| %>
          <input type="submit" class="btn btn-danger btn-xs" value="Remove Poster" <% if @collection.poster.blank? || cannot?(:edit, @collection) %>disabled<%end%> />
        <% end %>
      </div>
      <div class="well-vertical-spacer">
        <div id='cropper-alert' class="alert" role="alert" style="display: none; padding: 5px; margin-top: 5px"></div>
        <div id="cropper-progress" class="progress" style="display: none; margin-top: 7px;">
          <div id="cropper-progress-bar" class="progress-bar progress-bar-striped progress-bar-animated"
            role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100">0%</div>
        </div>
      </div>
    </div>
  </div>
  <div class="well-vertical-spacer">
    <%= link_to('Create An Item', new_media_object_path(collection_id: @collection.id), class: 'btn btn-primary') if can? :create, MediaObject %>
    <%= link_to('List All Items', search_catalog_path('f[collection_ssim][]' => @collection.name), class: 'btn btn-default') %>
    <%= button_tag('Edit Collection Info', class: 'btn btn-default', data: {toggle:"modal", target:"#new_collection"}) if can? :update, @collection %>
  </div>
  <div>
    <p>Or <a
        href='https://wiki.dlib.indiana.edu/display/VarVideo/Avalon+Collections+Guide#AvalonCollectionsGuide-UploadingviaBatch'><b>learn
          how to</b></a> create items using batch upload.</p>
  </div>
</div><!-- /well -->

<div class="panel panel-default">
  <div class="panel-heading">
    <h3 class="panel-title">Assign Staff Roles</h3>
  </div>
  <div class="panel-body">
    <div class='staff-roles-section'>
      <%= render "modules/access_object",
            access_object: "manager",
            members: @collection.managers,
            autocomplete_model: 'user',
            object: @collection,
            input_disabled: cannot?( :update_managers, @collection ) %>
      <%= render "modules/access_object",
            access_object: "editor",
            members: @collection.editors,
            autocomplete_model: 'user',
            object: @collection,
            input_disabled: cannot?( :update_editors, @collection ) %>
      <%= render "modules/access_object",
            access_object: "depositor",
            members: @collection.depositors,
            autocomplete_model: 'user',
            object: @collection,
            input_disabled: cannot?( :update_depositors, @collection ) %>
    </div>
  </div>
</div>

<div class="content-block">
  <h3 style="padding-top: 3rem;">Set Default Access Control for New Items</h3>
  <%= render "modules/access_control", { object: @collection, 
                                         visibility: @collection.default_visibility, 
                                         hidden: @collection.default_hidden, 
                                         modal: { partial: "apply_access_control", title: "Apply current Default Access settings to all existing Items" } } %>

  <% if can? :update_access_control, @collection %>
  <%= submit_tag "Save Access Settings", name: "save_access", class: "btn btn-primary", form: 'access_control_form' %>
  <%= button_tag "Apply to All Existing Items", class: "btn btn-default", data: { toggle:"modal", target:"#access_control_modal" } %>
  <% end %>
</div>

<%= render "form", modal_title: "Edit collection Information" %>

<% content_for :page_scripts do %>
<script>
  window.addEventListener('DOMContentLoaded', function () {
    add_cropper_handler('<%= attach_poster_admin_collection_path(@collection.id) %>');
  });
</script>
<% end %>